import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class ActivityCanvas extends TwoStateCanvas implements Observer, Runnable {
    
    /**
     *  The current state of this ActivityCanvas
     */
    private boolean currentState_;
    public boolean currentState() { return currentState_; }
    public void currentState( boolean aBoolean ) { currentState_ = aBoolean; }

    public ActivityCanvas() {
        this.initialize();
    }
    
    private void initialize( ){
        this.currentState(false);
        this.image1 = Toolkit.getDefaultToolkit().getImage("grayIndicator.GIF");
        this.image2 = Toolkit.getDefaultToolkit().getImage("greenIndicator.GIF");
        this.theImage = this.image1;

        this.setLocation(150,70);
        this.setSize(50,50);
        
        (new Thread(this)).start();
    }

    public void update(Observable obs, Object o){
        boolean command = ((Boolean) o).booleanValue();

        if( command ) {
            this.currentState(true);
        }
        else {
            this.currentState(false);
        }

    }
    
    public void run(){
        
        while (true) {
            if (this.currentState()) {
                this.stateTwo();
                this.longDelay();
                this.stateOne();
                this.shortDelay();
            }
            else {
                this.stateOne();
                this.longDelay();
                this.shortDelay();
            }
        }
    }

    private void shortDelay(){
        try{ Thread.sleep(200); }
        catch(InterruptedException ie){}
    }
    
    private void longDelay(){
        try{ Thread.sleep(400); }
        catch(InterruptedException ie){}
    }


}
