
import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import Configuration;
import ObservableRegistry;
import antview.AntFSMTraverserView;
import ant.StateMachineBlueprint;

public class BinaryParticlePositionList extends SCList implements Observer, MouseListener {
    
    /**
     *  The PopupMenu assiciated with this List
     */
    private PopupMenu popupMenu_;
    public PopupMenu popupMenu() { return popupMenu_; }
    public void popupMenu( PopupMenu aPopupMenu ) { popupMenu_ = aPopupMenu; }
    
    public BinaryParticlePositionList(BinaryParticleSwarmInspectorView theView) {
        super(theView);
        this.initialize();
    }
    
    private void initialize() {
        
        this.setSize(500,220);
        this.setLocation(30,480);
        this.setFont(new Font("Courier", Font.PLAIN, 11));
       // this.setBackground(Color.black);
      //  this.setForeground(new Color(Configuration.instance().hexValueOf("TEXTCOLOR")));
        
        this.addMouseListener(this);
        //this.setActionCommand("List Double Clicked");
        this.enableEvents(AWTEvent.MOUSE_EVENT_MASK);
        
        initPopupMenu();
        
        (ObservableRegistry.instance().obtainObservable("particle space")).addObserver(this);
    }
        
    public void initPopupMenu() {
        PopupMenu thePopup = new PopupMenu("Popup");
        /*
        MenuItem theMenuItem = new MenuItem("Execute Program");
        theMenuItem.addActionListener(this);
        theMenuItem.setActionCommand("Execute Program");
        thePopup.add(theMenuItem);
        
        theMenuItem = new MenuItem("-");
        
        theMenuItem = new MenuItem("File In Program");
        theMenuItem.addActionListener(this);
        theMenuItem.setActionCommand("File In Program");
        thePopup.add(theMenuItem);
        */
        MenuItem theMenuItem = new MenuItem("File Out ParticlePosition");
        theMenuItem.addActionListener(this);
        theMenuItem.setActionCommand("File Out ParticlePosition");
        thePopup.add(theMenuItem);
        
        this.popupMenu(thePopup);
        this.add(thePopup);
    }
    
    public void actionPerformed(ActionEvent e){

        String actionCommand = e.getActionCommand();
        //System.out.println(actionCommand);
        
        if( e.getSource() == this ){
            System.out.println("list double clicked");
            this.doubleClicked();
            return;
        }
        if( actionCommand.equals("Execute Program") ){
            System.out.println("Execute Program");
            return;
        }
        if( actionCommand.equals("File In Program") ){
            System.out.println("File In Program");
           return;
        }
        if( actionCommand.equals("File Out ParticlePosition") ){
            
            try {
                DataOutputStream theStreamOut = new DataOutputStream(new FileOutputStream ("particlepos.txt"));
                //this.properties().store(theStreamOut, "Artificial Ant Settings");
                StringBuffer s = new StringBuffer(this.getItem(0));
                //s.reverse(); // fixbg reverse it before displaying it ..
                             // so this will become unnecessary
                theStreamOut.writeBytes( s.toString());
                theStreamOut.close();
            }
            catch (IOException exception) { System.out.println("Particle Position Write Error"); }
            return;
        }
    }
    
    public int extractIDFromCurrentSelection() {
        String selection = this.getSelectedItem();
        StringTokenizer s = new StringTokenizer(selection);
        String searchKey = s.nextToken().trim();
        return (new Integer(searchKey)).intValue();
    }
    
    public void showActions() {
    }
    
    public synchronized void doubleClicked(){
        StateMachineBlueprint pos = (StateMachineBlueprint) 
                               BinaryParticlePosition.fromString(this.getItem(0));
                               
        AntFSMTraverserView theView = new AntFSMTraverserView("Ant Tryouts", pos);
        
        //this.showActions();
  //      int theID = this.extractIDFromCurrentSelection();
  //      ((ParticleSwarmSimulatorView) this.theSCView()).evaluateParticleWithID(theID);
    }
    
    public void itemStateChanged(ItemEvent ie){
        System.out.println("item event = " + ie.getItem());
   //     int theID = this.extractIDFromCurrentSelection();
   //     ((ParticleSwarmSimulatorView) this.theSCView()).showProgramListFor(theID);
    }
    
    public void mouseClicked(MouseEvent e) {
        // sun does it on click
        if (e.isPopupTrigger()) popupThePopup(e);
    }
    
    public void mouseReleased(MouseEvent e) {
        // windows does it on release
        if (e.isPopupTrigger()) popupThePopup(e);
    }
    
    public void popupThePopup(MouseEvent e) {
        int xPos = e.getX();
        int yPos = e.getY();
        this.popupMenu().show(this, xPos+20, yPos+20);
        //this.popupMenu().show(this.getParent(), e.getX()+20, e.getY()+20);
    }
    
    public void mousePressed(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}
    
    public synchronized void update (Observable obs, Object o) {
        
        StringBuffer s = new StringBuffer(100);
                
        BinaryParticlePosition thePosition = (BinaryParticlePosition) o;
        BinaryParticleSpace particleSpace = (BinaryParticleSpace) obs;
        
        this.setVisible(false);
        this.removeAll();
        
      /*  
        for (int i=0; i<thePosition.dimension(); i++) {
            if (((i % 64) == 0) && (i !=0)) {
                //this.add(s.reverse().toString());
                this.add(s.toString());
                s = new StringBuffer(100);
            }       
            s.append (thePosition.valueAt(i));
        }
        
        if (s.length() != 0)
            this.add(s.reverse().toString());
        */
        
        for (int i=0; i<thePosition.dimension(); i++) {
            s.append (thePosition.valueAt(i));
        }
        this.add(s.toString());
        
        // now show the description
        
        this.add(" ");
        
        Vector description = particleSpace.descriptionOf(thePosition);
        
        Enumeration theOC = description.elements();
        while(theOC.hasMoreElements()) {
            String programLine = (String) theOC.nextElement();
            this.add(programLine);
        }
        
         
                        
        this.setVisible(true);
      //  Thread.yield(); // let the render thread have a chance
      //  try{Thread.sleep(100);} catch(InterruptedException e){}
        
    }
    
        
    public void update(Graphics g) {  paint(g);  }
    
}