
import java.util.*;

public class BinaryParticlePredisposition {
    
    /**
     *  Predispositions of particle to be a one
     */
    private double[] predispositions_;
    public double[] predispositions() { return predispositions_; }
    public void predispositions( double[] aPredisposition ) { predispositions_ = aPredisposition; }

    /**
     *  Count to support the Enumeration interface
     */
    private int enumerationCount_;
    private int enumerationCount() { return enumerationCount_; }
    private void enumerationCount( int anInt ) { enumerationCount_ = anInt; }
    
    /**
     *  The dimension of this ParticleVelocity
     */
    private int dimension_;
    public int dimension() { return dimension_; }
    public void dimension( int anInt ) { dimension_ = anInt; }


    public BinaryParticlePredisposition() {
        this.initialize();
    }
    
    public BinaryParticlePredisposition(int dimension) {
        this();
        this.dimension(dimension);
        this.predispositions(new double[this.dimension()]);
    }
    
    private void initialize() {
        this.dimension(2);
        this.predispositions(new double[this.dimension()]);
    }
    
    public double valueAt(int position) {
        return this.predispositions()[position];
    }
    
    public void valueAt(int position, double value) {
        this.predispositions()[position] = value;
    }
    
    public Enumeration elements() {
        this.enumerationCount(0);
        return (Enumeration) this;
    }
    
    public boolean hasMoreElements() {
        return (this.enumerationCount() < this.dimension());
    }
    
    public double nextElement() {
        double v = this.valueAt(this.enumerationCount());
        this.enumerationCount(this.enumerationCount()+1);
        return v;
    }
    
}
