import java.util.*;
import java.io.*;
import java.text.*;

public class DataLogger {
    
    /**
     *  Source of info for the DataLogger
     */
    private DataLoggerClient dataLoggerClient_;
    private DataLoggerClient dataLoggerClient() { return dataLoggerClient_; }
    private void dataLoggerClient( DataLoggerClient aDataLoggerClient ) { dataLoggerClient_ = aDataLoggerClient; }
    
    /**
     *  Stream for writing log to disk
     */
    private PrintStream printStream_;
    public PrintStream printStream() { return printStream_; }
    public void printStream( PrintStream aPrintStream ) { printStream_ = aPrintStream; }

    /**
     *  Keeps track of interwrite counts
     */
    private int currentCount_;
    public int currentCount() { return currentCount_; }
    public void currentCount( int anInt ) { currentCount_ = anInt; }
        
    private DataLogger() {
        this.initialize();
    }
    
    public DataLogger(DataLoggerClient client) {
        this();
        this.dataLoggerClient(client);
        this.dataLoggerClient().logHeaderToPrintStream(this.printStream());
    }
    
    private void initialize() {
        
        this.dataLoggerClient(null);
        
        this.currentCount(0);
        
        try {
            this.printStream(new PrintStream(new FileOutputStream("ledger.txt")));
        }
        catch (FileNotFoundException e) {
            System.out.println("File error in DataLogger");
        }
    }
            
    public void writeToLog(String s) {

        this.currentCount(this.currentCount() + 1);
        
        if (this.dataLoggerClient().includeTimestamp()) {
            Calendar rightNow = Calendar.getInstance();
            String dateString = DateFormat.getDateTimeInstance()
                                       .format(rightNow.getTime());
            this.printStream().print(dateString + " ");
        }
            
        this.printStream().println(s);
        this.printStream().flush();
    }
    
}
        
