
import java.util.*;
import java.text.*;

public class ExponentialFormat {
    
    public ExponentialFormat() {
        this.initialize();
    }
    
    private void initialize() {
    }
    
    public String format(double r) {
        
        double result = 0.0;
        int exp = 0;
        
        String sign = "";
        boolean negativeFlag = false;
        
        if (r < 0.0) {
            negativeFlag = true;
            r = Math.abs(r);
        }
        
        if (r != 0.0) {
        
            double lnr = Math.log(r);
            double ln10 = Math.log(10);
            double log10 = lnr/ln10;
            exp = (int) Math.floor(log10);
            // now divide
            result = r / (Math.pow(10.0, exp));
            
            if (negativeFlag) {
                sign = "-";
            }
        }
        
        DecimalFormat f = new DecimalFormat("0.000");
        return ("" + sign + f.format(result) + " E" + exp);   
    } 
}