
import java.util.*;

public class ObservableRegistry {
    
    private static ObservableRegistry instance_ = null;

    /**
     *  The observables registered here
     */
    private Hashtable observables_;
    public Hashtable observables() { return observables_; }
    public void observables( Hashtable anHashtable ) { observables_ = anHashtable; }
    
    public synchronized static ObservableRegistry instance() {
        if (instance_ == null)
            instance_ = new ObservableRegistry();
        return instance_;
    }
    
    private ObservableRegistry() {
        this.initialize();
    }

    private void initialize() {
        this.observables(new Hashtable());
    }
    
    public void register(String name, Observable theObservable) {
        System.out.println("register observable = " + theObservable);
        this.observables().put(name, theObservable);
    }
    
    public Observable obtainObservable(String theObservableName) {
        Observable theObservable = (Observable) this.observables().get(theObservableName);
        if (theObservable == null) {
             System.out.println("Observable missing from registry");
        }
        System.out.println("obtainObservable = " + theObservable);
        return theObservable;
    }
}