
import java.util.*;
import java.awt.Color;

public class Particle {

	/**
	 *  A buddy of this Particle
	 */
	private Particle companionA_;
	public Particle companionA() { return companionA_; }
	public void companionA( Particle aParticle ) { companionA_ = aParticle; }

	/**
	 *  Another buddy of this Particle
	 */
	private Particle companionB_;
	public Particle companionB() { return companionB_; }
	public void companionB( Particle aParticle ) { companionB_ = aParticle; }

	/**
	 *  ParticlePosition which contains the best position
	 *  obtained so far for this individual Particle
	 */
	private BinaryParticlePosition bestPositionSoFar_;
	public BinaryParticlePosition bestPositionSoFar() { return bestPositionSoFar_; }
	public void bestPositionSoFar( BinaryParticlePosition aParticlePosition ) { bestPositionSoFar_ = aParticlePosition; }
	
    /**
	 *  BinaryParticlePosition which contains the current position
	 *  for this individual Particle
	 */
    private BinaryParticlePosition currentPosition_;
    public BinaryParticlePosition currentPosition() { return currentPosition_; }
    public void currentPosition( BinaryParticlePosition aParticlePosition ) { currentPosition_ = aParticlePosition; }

	/**
     *  BinaryParticlePredisposition which contains the current predispositions 
     *  for this individual Particle
	 */
	private BinaryParticlePredisposition currentPredisposition_;
    public BinaryParticlePredisposition currentPredisposition() { return currentPredisposition_; }
    public void currentPredisposition( BinaryParticlePredisposition aParticlePredisposition ) { currentPredisposition_ = aParticlePredisposition; }

    public Particle(BinaryParticlePosition p, BinaryParticlePredisposition v) {
        this();
        this.currentPosition  (p);
        this.bestPositionSoFar(new BinaryParticlePosition(p.dimension()));
        this.bestPositionSoFar().setPositionToPositionOf(p);
        this.currentPredisposition(v);
    }

    private Particle() {
        this.initialize();
    }
    
    private void initialize() {
       
        // these will be initialized later
        this.companionA(null);
        this.companionB(null);
    }
        
    public void advanceOneTimeStep() {
        
    }    
}