  
import java.util.*;
import java.awt.*;
import java.awt.Color.*;
import java.awt.event.*;

public class ParticleSwarmSimulatorView extends SCView {

    /**
     *  Simulates PSO per Jamwa Kennedy
     */
    private ParticleSwarmSimulator particleSwarmSimulator_;
    public ParticleSwarmSimulator particleSwarmSimulator() { return particleSwarmSimulator_; }
    public void particleSwarmSimulator( ParticleSwarmSimulator aParticleSwarmSimulator ) { particleSwarmSimulator_ = aParticleSwarmSimulator; }

    /**
     *  The number of trials remaining from user selection
     */
    private int trialCount_;
    public int trialCount() { return trialCount_; }
    public void trialCount( int anInt ) { trialCount_ = anInt; }

    public static void main(String args[]) {
        
        /*
         * Testing region
         *
         */
         
        /*
        StringBuffer s = new StringBuffer(50);
        s.append("test");
        //System.out.println(s.toString() + " 2 " + s.toString());
        */
        
        ParticleSwarmSimulatorView theView = new ParticleSwarmSimulatorView();
        //theView.startTheEngine();
        theView.show();
       
    }

    public ParticleSwarmSimulatorView() {
        super("Particle Swarm Simulator");
        this.initialize();
    }
    
    private void initialize() {	
        // force creation of main model
        this.particleSwarmSimulator(new ParticleSwarmSimulator());
        this.trialCount(0); 
        
        // and an inspector view and inspector ..
        // .. handing the inspector a custodian seems reasonable but
        // the view should not be messing around in the model .. is
        // there a better way to do this?? fixbg
        
        this.setLayout(null);
        this.setSize(230,250);
        this.setLocation(20,20);
        this.setResizable(false);
        this.initLabels();
        this.initCanvasses();
        this.hookupObservers();
        this.initMenus();
        
        /*
        new BinaryParticleSwarmInspectorView(this, this.particleSwarmSimulator().
                                                           particleSwarmCustodian());
        */
    }
    
    
    public void hookupObservers() {
        this.particleSwarmSimulator().addObserver(this);
    } 
    
    public void initLabels() {
        Label aLabel = new Label("Activity");
        aLabel.setFont(new Font("Ariel", Font.PLAIN, 15));
        aLabel.setLocation(70, 82);
        aLabel.setSize(80,30);
        aLabel.setForeground(Color.orange);
        this.add(aLabel);
    }
        
    
    public void initMenus() {
        
        MenuBar aMenuBar = new MenuBar();
        
            Menu aMenu = new Menu("File");
                /*
                MenuItem aMenuItem = new MenuItem("New");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("New");
                aMenu.add(aMenuItem);
                */
                
                MenuItem aMenuItem = new MenuItem("Exit");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Exit");
                aMenu.add(aMenuItem);
            aMenuBar.add(aMenu);
            /*    
            aMenu = new Menu("Edit");
                aMenuItem = new MenuItem("Copy");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Copy");
                aMenu.add(aMenuItem);
                
                aMenuItem = new MenuItem("Paste");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Paste");
                aMenu.add(aMenuItem);
            aMenuBar.add(aMenu);
            */
            aMenu = new Menu("Action");
                aMenuItem = new MenuItem("Perform Trial");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Perform Trial");
                aMenu.add(aMenuItem);
                /*
                aMenuItem = new MenuItem("Perform Trial Set");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Perform Trial Set");
                aMenu.add(aMenuItem);
                */
                aMenuItem = new MenuItem("Stop");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Stop");
                aMenu.add(aMenuItem);
            aMenuBar.add(aMenu);
            
            aMenu = new Menu("View");
                aMenuItem = new MenuItem("Particle Space");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Particle Space");
                aMenuItem.setEnabled(false);
                this.addMenuItem("viewParticleSpaceMenuItem", aMenuItem);
                aMenu.add(aMenuItem);
                /*
                aMenuItem = new MenuItem("Statistics");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("Statistics");
                aMenu.add(aMenuItem);
                
                aMenuItem = new MenuItem("-");
                aMenuItem.addActionListener(this);
                aMenuItem.setActionCommand("separator");
                aMenu.add(aMenuItem);
                */
            aMenuBar.add(aMenu);

        this.setMenuBar(aMenuBar);
    }
    
    public void initCanvasses() {
        
        this.addWidget("activityCanvas", new ActivityCanvas());
        /*
        TorroidialFieldCanvas theCanvas = new TopologicalFieldCanvas();
        //TorroidialFieldCanvas theCanvas = new TorroidialFieldCanvas();
        theCanvas.setSize(Configuration.instance().intValueOf("CANVASWIDTH"),
                              Configuration.instance().intValueOf("CANVASHEIGHT"));
        theCanvas.setLocation(30,60);
        ObservableRegistry.instance().obtainObservable("fieldone").addObserver(theCanvas);
        this.addWidget("field canvas", theCanvas);
        */
    }
    
   public void actionPerformed(ActionEvent e){

        String actionCommand = e.getActionCommand();
        
        /*
        if( actionCommand.equals("New") ) {
            //this.setupEvolutionaryParameters();
            return;
        }
        */
        if( actionCommand.equals("Exit") ){
            this.exit();
            return;
        }
        if( actionCommand.equals("Copy") ){
            this.copyToClipboard();
            return;
        }
        if( actionCommand.equals("Paste") ){
            this.pasteFromClipboard();
            return;
        }
        if( actionCommand.equals("Perform Trial") ){
            ((MenuItem) this.getMenuItem(
                   "viewParticleSpaceMenuItem")).
                                        setEnabled(true);
            ((ActivityCanvas) this.getWidget("activityCanvas")).
                                                 currentState(true);
            this.performOneTrial();
            return;
        }
        if( actionCommand.equals("Perform Trial Set") ){
            this.performTrialSet();
            //this.continuousEvolution();
            return;
        }
        if( actionCommand.equals("Stop") ){
            this.stopAllThreads(); // fixbg .. still some problems ..
            ((MenuItem) this.getMenuItem(
                   "viewParticleSpaceMenuItem")).
                                        setEnabled(false);
            ((ActivityCanvas) this.getWidget("activityCanvas")).
                                                 currentState(false);
            return;
        }
        if( actionCommand.equals("Particle Space") ) {
            this.openParticleSpaceInspector();
            //this.spawnPopulationViewer();
            return;
        }
        /*
        if( actionCommand.equals("Statistics") ){
            //this.displayStatistics();
            return;
        }
        */
   }
   
    // methods associated with Menus
   
    public void stopAllThreads() {
        this.particleSwarmSimulator().stopAllThreads();
        ((BinaryParticleSwarmInspectorView) 
                  this.getSubView("inspector")).stopAllThreads();
    }
    
   
    public void copyToClipboard() {
        System.out.println("copying to clipboard");
    }
    
    public void pasteFromClipboard() {
    }

    public void windowClosing(WindowEvent we){
        this.exit();
    }

    private void exit(){
        this.dispose();
        System.exit(0);
    }
    
    // misc methods
    
    public void update (Observable obs, Object o) {
        // trial is complete
        System.out.println("inside view update");
        this.trialCount(this.trialCount()-1);
        if (this.trialCount()>0) {
            this.performOneTrial();
        }
    }
    
    public void reset() {
        this.particleSwarmSimulator(new ParticleSwarmSimulator());
        this.hookupObservers();
    }
    
    
    // Methods to support menus
    
    public void startTheEngine() {
        this.particleSwarmSimulator().startTheEngine();
    }
    
    public void performOneTrial() {
        this.reset();
        this.startTheEngine();
    }
    
    public void performTrialSet() {
        this.trialCount(3);
        this.performOneTrial();
    }
    
    public void openParticleSpaceInspector() {
        
        BinaryParticleSwarmInspectorView inspectorView =
                       new BinaryParticleSwarmInspectorView
                         (this, this.particleSwarmSimulator().
                                       particleSwarmCustodian());
        this.addSubView("inspectorView", inspectorView);
    }
    
    public void paint(Graphics g) {
        g.drawRect(20,60,190,190);
    }
    
    public void update(Graphics g) {  paint(g);  }
            
}