
import java.util.*;
import java.awt.Color;

public class Randomizer {
    
    // A singleton ..
    
    private static Randomizer instance_ = null;
    
    public synchronized static Randomizer instance() {
        if (instance_ == null)
            instance_ = new Randomizer();
        return instance_;
    }

    /**
     *  An instance of class Random helps this Randomizer
     *  perform most of the funtions required
     */
    private Random random_;
    public Random random() { return random_; }
    public void random( Random aRandom ) { random_ = aRandom; }    
    
    public Randomizer() {
        this.initialize();
    }
    
    private void initialize() {
        this.random(new Random(Configuration.instance().intValueOf("RANDOMSEED")));
    }
    
    public double next() {
        return this.random().nextDouble();
    }
    
    public boolean nextBit() {
        if (this.next() > 0.5) {
            return true;
        }
        return false;
    }
        
    public int nextIntegerBetween(int low, int high) { //inclusive

        double s = this.next();
        double r = s * (high - low + 1);

        if (r >= (high-low+1)) {  // i do not think this can happen
            return high;         // but just in case ..
        }
        return (((int) Math.floor (r)) + low);
    }
    
    public Color nextColor()  {
        int r = (int) (Randomizer.instance().next() * 255.0);
        int g = (int) (Randomizer.instance().next() * 255.0);
        int b = (int) (Randomizer.instance().next() * 255.0);
        long result = 0;
        result += 0xff << 24;
        result += r << 16;
        result += g << 8;
        result += b;
        return new Color((int) result);
    }
    
}