package ant;

import java.util.*;
import java.awt.Point;
import Configuration;

public class FoodPlain extends Observable {
    
    // grid element values ..
    
    public static byte EMPTY = 0;
    public static byte FOOD  = 1;
    public static byte ANT   = 2;

    /**
     *  The grid which makes up the FoodPlain
     */
    private byte[][] grid_;
    public byte[][] grid() { return grid_; }
    public void grid( byte[][] aByteArray ) { grid_ = aByteArray; }
    
    public FoodPlain() {
        this.initialize();
    }
    
    private void initialize() {
        int gridWidth  = Configuration.instance().intValueOf("GRIDWIDTH");
        int gridHeight = Configuration.instance().intValueOf("GRIDHEIGHT");
        this.grid(new byte[gridWidth][gridHeight]);
        this.setoutFood();
    }
    
    public void reset() {
       int gridWidth  = Configuration.instance().intValueOf("GRIDWIDTH");
       int gridHeight = Configuration.instance().intValueOf("GRIDHEIGHT");
       for (int i=0; i<gridWidth; i++) {
            for (int j=0; j<gridHeight; j++) {
                this.grid()[i][j] = FoodPlain.EMPTY;
            }
        }
        this.setoutFood();
    }
    
    public void publicize(AntBody theAntBody) {
        this.setChanged();
        this.notifyObservers(theAntBody);
    }
    
    public boolean hasFoodAt(Point gridLocation) {
        return (this.grid()[gridLocation.x][gridLocation.y] == FoodPlain.FOOD);
    }
    
    public void removeFoodAt(Point gridLocation) {
        this.grid()[gridLocation.x][gridLocation.y] = FoodPlain.EMPTY;
        //this.publicize(theAntBody); // scanforme
    }
    
    public void setoutFood() {
        
        this.grid()[2][1]   = FoodPlain.FOOD;
        this.grid()[2][1]   = FoodPlain.FOOD;  
        this.grid()[3][1]   = FoodPlain.FOOD; 
        this.grid()[4][1]   = FoodPlain.FOOD; 
        this.grid()[4][2]   = FoodPlain.FOOD; 
        this.grid()[4][3]   = FoodPlain.FOOD; 
        this.grid()[4][4]   = FoodPlain.FOOD;
        this.grid()[4][5]   = FoodPlain.FOOD;  
        this.grid()[4][6]   = FoodPlain.FOOD; 
        this.grid()[5][6]   = FoodPlain.FOOD; 
        this.grid()[6][6]   = FoodPlain.FOOD; 
        this.grid()[7][6]   = FoodPlain.FOOD;
        this.grid()[9][6]   = FoodPlain.FOOD;  
        this.grid()[10][6]  = FoodPlain.FOOD; 
        this.grid()[11][6]  = FoodPlain.FOOD; 
        this.grid()[12][6]  = FoodPlain.FOOD; 
        this.grid()[13][6]  = FoodPlain.FOOD;
        this.grid()[13][7]  = FoodPlain.FOOD; 
        this.grid()[13][8]  = FoodPlain.FOOD; 
        this.grid()[13][9]  = FoodPlain.FOOD; 
        this.grid()[13][10] = FoodPlain.FOOD;
        this.grid()[13][12] = FoodPlain.FOOD; 
        this.grid()[13][13] = FoodPlain.FOOD; 
        this.grid()[13][14] = FoodPlain.FOOD; 
        this.grid()[13][15] = FoodPlain.FOOD;
        this.grid()[13][18] = FoodPlain.FOOD; 
        this.grid()[13][19] = FoodPlain.FOOD; 
        this.grid()[13][20] = FoodPlain.FOOD; 
        this.grid()[13][21] = FoodPlain.FOOD; 
        this.grid()[13][22] = FoodPlain.FOOD;
        this.grid()[13][23] = FoodPlain.FOOD; 
        this.grid()[13][24] = FoodPlain.FOOD;
        this.grid()[12][25] = FoodPlain.FOOD; 
        this.grid()[11][25] = FoodPlain.FOOD; 
        this.grid()[10][25] = FoodPlain.FOOD; 
        this.grid()[9][25]  = FoodPlain.FOOD; 
        this.grid()[8][25]  = FoodPlain.FOOD;
        this.grid()[5][25]  = FoodPlain.FOOD; 
        this.grid()[4][25]  = FoodPlain.FOOD; 
        this.grid()[2][26]  = FoodPlain.FOOD; 
        this.grid()[2][27]  = FoodPlain.FOOD; 
        this.grid()[2][28]  = FoodPlain.FOOD; 
        this.grid()[2][29]  = FoodPlain.FOOD;
        this.grid()[3][31]  = FoodPlain.FOOD; 
        this.grid()[4][31]  = FoodPlain.FOOD; 
        this.grid()[5][31]  = FoodPlain.FOOD; 
        this.grid()[6][31]  = FoodPlain.FOOD; 
        this.grid()[8][30]  = FoodPlain.FOOD; 
        this.grid()[8][29]  = FoodPlain.FOOD;
        this.grid()[9][28]  = FoodPlain.FOOD; 
        this.grid()[10][28] = FoodPlain.FOOD; 
        this.grid()[11][28] = FoodPlain.FOOD; 
        this.grid()[12][28] = FoodPlain.FOOD; 
        this.grid()[13][28] = FoodPlain.FOOD; 
        this.grid()[14][28] = FoodPlain.FOOD;
        this.grid()[15][28] = FoodPlain.FOOD; 
        this.grid()[17][27] = FoodPlain.FOOD; 
        this.grid()[17][26] = FoodPlain.FOOD; 
        this.grid()[17][25] = FoodPlain.FOOD; 
        this.grid()[17][22] = FoodPlain.FOOD; 
        this.grid()[17][21] = FoodPlain.FOOD;
        this.grid()[17][20] = FoodPlain.FOOD; 
        this.grid()[17][19] = FoodPlain.FOOD; 
        this.grid()[18][16] = FoodPlain.FOOD; 
        this.grid()[21][15] = FoodPlain.FOOD; 
        this.grid()[21][14] = FoodPlain.FOOD;
        this.grid()[21][11] = FoodPlain.FOOD; 
        this.grid()[21][10] = FoodPlain.FOOD; 
        this.grid()[21][9]  = FoodPlain.FOOD; 
        this.grid()[21][8]  = FoodPlain.FOOD; 
        this.grid()[22][6]  = FoodPlain.FOOD; 
        this.grid()[23][6]  = FoodPlain.FOOD;
        this.grid()[25][5]  = FoodPlain.FOOD; 
        this.grid()[25][4]  = FoodPlain.FOOD; 
        this.grid()[26][3]  = FoodPlain.FOOD; 
        this.grid()[27][3]  = FoodPlain.FOOD; 
        this.grid()[28][3]  = FoodPlain.FOOD; 
        this.grid()[30][4]  = FoodPlain.FOOD;
        this.grid()[30][5]  = FoodPlain.FOOD; 
        this.grid()[30][7]  = FoodPlain.FOOD; 
        this.grid()[30][10] = FoodPlain.FOOD; 
        this.grid()[30][13] = FoodPlain.FOOD; 
        this.grid()[29][15] = FoodPlain.FOOD; 
        this.grid()[28][15] = FoodPlain.FOOD;
        this.grid()[27][15] = FoodPlain.FOOD; 
        this.grid()[24][16] = FoodPlain.FOOD; 
        this.grid()[25][19] = FoodPlain.FOOD; 
        this.grid()[28][20] = FoodPlain.FOOD; 
        this.grid()[27][23] = FoodPlain.FOOD;
        this.grid()[24][24] = FoodPlain.FOOD;
    }
}