package antview;

import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class AntCanvas extends MoveableCanvas {
            
    /**
     *  The images (one for each of the four directions)
     *  associated with this ant.
     */
    private Vector images_;
    public Vector images() { return images_; }
    public void images( Vector aVector ) { images_ = aVector; }
    
    public AntCanvas(Point location) {
        super(location);
        this.initialize();
    }
    
    private void initialize() {
        this.images(new Vector());
        this.setSize(15, 15);
        this.loadImages();
        this.image((Image)this.images().elementAt(1)); // for a start
        this.setVisible(false);
    }
    
    public void loadImages() {
        this.images().addElement(Toolkit.getDefaultToolkit().getImage("antbn.GIF"));
        this.images().addElement(Toolkit.getDefaultToolkit().getImage("antbe.GIF"));
        this.images().addElement(Toolkit.getDefaultToolkit().getImage("antbs.GIF"));
        this.images().addElement(Toolkit.getDefaultToolkit().getImage("antbw.GIF"));
        this.images().addElement(Toolkit.getDefaultToolkit().getImage("noantb.GIF"));
        MediaTracker mt = new MediaTracker(this);
        Enumeration theOC = this.images().elements();
        int i=0;
        while (theOC.hasMoreElements()) {
            mt.addImage((Image) theOC.nextElement(), i);
            i++;
        }
        try {
            mt.waitForAll();
        }
        catch (InterruptedException e) {
            System.out.println("Media Tracker interrupted ..");
        }
    }
    
    public void updateAntPositionAndDirection(Point drawPosition, int currentAntDirection) {
        this.setVisible(false);
        // set the image and location
        this.setLocation(drawPosition.x, drawPosition.y);
        this.image((Image) this.images().elementAt(currentAntDirection/90));
       // this.repaint();
        this.setVisible(true);
    }
}