package antview;

import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class FoodCanvas extends MoveableCanvas {
    
    // static variable
    
    /**
     *  The images (several different looking pieces of food)
     *  associated with this FoodCanvas.
     */
    private static Image[] images_ = new Image[3];
    public static Image[] images() { return images_; }
    public static void images( Image[] anArray ) { images_ = anArray; }
    
    // static initializer
    
    static {
        images_[0] = Toolkit.getDefaultToolkit().getImage("foodblacka.GIF");
        images_[1] = Toolkit.getDefaultToolkit().getImage("foodblackb.GIF"); // foodb.GIF
        images_[2] = Toolkit.getDefaultToolkit().getImage("foodblackc.GIF"); // foodc.GIF
        System.out.println("food image loading requested ..");
    }
    
    /**
     *  The grid location (not the pixel location) of this FoodCanvas
     */
    private Point gridLocation_;
    public Point gridLocation() { return gridLocation_; }
    public void gridLocation( Point aPoint ) { gridLocation_ = aPoint; }
    
    public FoodCanvas(Point gridLocation, Point panelLocation) {
        super(panelLocation);
        this.gridLocation(gridLocation);
        this.initialize();
    }
        
    private void initialize() {
        this.setSize(15, 15);
        this.setFoodImageRandomly();
    }
    
    public void setFoodImageRandomly() {
        int j = (int) Math.floor(Math.random() * FoodCanvas.images().length);
        if (j == 3) System.out.println("I thought this could never happen");
        this.image(FoodCanvas.images()[j]);
    }
    
    public void makeVisible() {
        this.visible(true);
        this.setVisible(true);
       // this.repaint();
    }
    
    public void makeInvisible() {
        this.visible(false);
        this.setVisible(false);
    }
}