package antview;

import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class MoveableCanvas extends Canvas {

    /**
     *  True is this canvas will be visible when drawn
     */
    private boolean visible_;
    public boolean visible() { return visible_; }
    public void visible( boolean aBoolean ) { visible_ = aBoolean; }

    /**
     *  The image associated with this Canvas
     */
    private Image image_;
    public Image image() { return image_; }
    public void image( Image anImage ) { image_ = anImage; }
    
    public MoveableCanvas(Point location) {
        this();
        this.setLocation(location.x, location.y);
    }
    
    private MoveableCanvas() {
        this.initialize();
    }
    
    private void initialize() {
        this.visible(true);
        this.setVisible(true);
    }
    
    public void paint(Graphics g) {
        g.drawImage(this.image(), 0, 0, this);
    }
    
    public void update(Graphics g) {  paint(g);  }
    
}