package graph;

import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class BarGraphCanvas extends GraphCanvas {
    
    private static final int GRIDCOLOR  = 0xff999999;
    private static final int BACKCOLOR  = 0xffffffff;
    private static final int PADCOLOR   = 0xff005555;
    private static final int TITLECOLOR = 0xffaa5500;
    
    public BarGraphCanvas() {
        this.initialize();
    }
    
    public BarGraphCanvas(String title) {
        this();
        this.title(title);
   }
    
    private void initialize() {
    }
    
    public void drawGraph(Graphics g) {
        if (this.graphInsets() == null) {return; }

        g.setColor(new Color(BarGraphCanvas.PADCOLOR));
        int xDelta = this.graphInsets().right  - this.graphInsets().left;
        int yDelta = this.graphInsets().bottom - this.graphInsets().top;

        Point base = new Point(this.graphInsets().left,
                                           this.graphInsets().bottom);
        double xMin = this.graph().minX();
        double yMin = this.graph().minY();
        double xMax = this.graph().maxX();
        double yMax = this.graph().maxY();

        double xRange = (double) (xMax - xMin);
        double yRange = (double) (yMax - yMin);

        double xScale = xDelta / xRange;
        double yScale = yDelta / yRange;

        // now let's prepare a little more

        Enumeration theData = this.graph().elements();
        RealNumberPoint aPoint = null;
        double xP = 0.0;
        double yP = 0.0;
        int xPixels = 0;
        int yPixels = 0;
          
        // shift it so the bar is centered at x,y ??
        
        // draw everybody
        while(theData.hasMoreElements()) {
            aPoint = (RealNumberPoint) theData.nextElement();
            xP = (double) aPoint.x - xMin;
            yP = (double) aPoint.y - yMin;
            xPixels = (int) (xP * xScale);
            yPixels = (int) (yP * yScale);
            g.fillRect ((base.x + xPixels), (base.y - yPixels), 2, yPixels);
        }

    }
}